# C++ keyword: `decltype` (since C++11)

From cppreference.com
< cpp‎ | keyword

### Usage

- `decltype` specifier

- decltype(auto)

(since C++14)

### Notes

Feature-test macro | Value | Std | Feature
--- | --- | --- | ---
`__cpp_decltype` | `200707L` | (C++11) | `decltype`
`__cpp_decltype_auto` | `201304L` | (C++14) | Return type deduction for normal functions

### See also

- `auto` (`auto` placeholder type specifier)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/keyword/decltype&oldid=174917"